/*
   _____            .__             ___.           __
 _/ ____\_ __  _____|__| ____   ____\_ |__   _____/  |_
 \   __\  |  \/  ___/  |/  _ \ /    \| __ \ /  _ \   __\
  |  | |  |  /\___ \|  (  <_> )   |  \ \_\ (  <_> )  |
  |__| |____//____  >__|\____/|___|  /___  /\____/|__|
                  \/               \/    \/

	fusionbot.h
	Main header file for FUSIONBOT
================================================================
Should you decide to release a modified version of FUSION, you MUST
include the following text in the documentation and source of your
modification.

---===[BEGIN TEXT]===---
================================================================
___________           .__                __________        __
\_   _____/_ __  _____|__| ____   ____   \______   \ _____/  |_
 |    __)|  |  \/  ___/  |/  _ \ /    \   |    |  _//  _ \   __\
 |     \ |  |  /\___ \|  (  <_> )   |  \  |    |   (  <_> )  |
 \___  / |____//____  >__|\____/|___|  /  |______  /\____/|__|
     \/             \/               \/          \/  Version 2.0
================================================================
Fusion v2.0
Copyright (c) 1998-2003 Trenton Shaffer.
All rights reserved.

ACEBOT Copyright(c) 1998, Steve Yeager.
EraserBot Copyright(c) 1998, Ryan Feltrin.
QFusion is Copyright (C) 2002-2003 Victor Luchits.
All other files are Copyright(C) 1997-2001 Id Software, Inc.
================================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
================================================================
---===[END TEXT]===---
*/
#ifndef _FUSIONBOT_H
#define _FUSIONBOT_H

//  ___       __ _      _ _   _
// |   \ ___ / _(_)_ _ (_) |_(_)___ _ _  ___
// | |) / -_)  _| | ' \| |  _| / _ \ ' \(_-<
// |___/\___|_| |_|_||_|_|\__|_\___/_||_/__/
//------------------------------------------------------------------------------------
#define MAX_BOTS			32				// Maximum Bots (32)
#define MAX_NODES			1200			// Maximum Nodes (1200)
#define NODE_DENSITY		128				// Node Density
#define MAXLINKS			12				// Maximum Node Links (12)
#define INVALID				-1				// Invalid Node Link
extern	cvar_t				*botchat;		// Bot Chat, off/on (0,1)
extern  cvar_t				*showpath;		// Show bot paths
//------------------------------------------------------------------------------------

//  ___ _      _    __                 ___ _____ _ _____ ___
// | _ \ |__ _| |_ / _|___ _ _ _ __   / __|_   _/_\_   _| __|
// |  _/ / _` |  _|  _/ _ \ '_| '  \  \__ \ | |/ _ \| | | _|
// |_| |_\__,_|\__|_| \___/_| |_|_|_| |___/ |_/_/ \_\_| |___|
//------------------------------------------------------------------------------------
#define	PLATFORM_STATE_TOP			0	// Platform State Top
#define	PLATFORM_STATE_BOTTOM		1	// Platform State Bottom
#define PLATFORM_STATE_UP			2	// Platform State Moving Up
#define PLATFORM_STATE_DOWN			3	// Platform State Moving Down
//------------------------------------------------------------------------------------

//  _  _         _       _____
// | \| |___  __| |___  |_   _|  _ _ __  ___ ___
// | .` / _ \/ _` / -_)   | || || | '_ \/ -_|_-<
// |_|\_\___/\__,_\___|   |_| \_, | .__/\___/__/
//                            |__/|_|
//------------------------------------------------------------------------------------
#define NODE_MOVE			0			// Move Node
#define NODE_LADDER			1			// Ladder Node
#define NODE_PLATFORM		2			// Platform Node
#define NODE_TELEPORTER		3			// Teleporter Node
#define NODE_ITEM			4			// Item Node
#define NODE_WATER			5			// Water Node
#define NODE_GRAPPLE		6			// Grapple Node
#define NODE_JUMP			7			// Jump Node
#define	NODE_FLAG1			8			// Red Flag Node
#define	NODE_FLAG2			9			// Blue Flag Node
#define NODE_ALL			99			// For selecting all nodes
//------------------------------------------------------------------------------------

//  ___      _     ___ _____ _ _____ ___
// | _ ) ___| |_  / __|_   _/_\_   _| __|
// | _ \/ _ \  _| \__ \ | |/ _ \| | | _|
// |___/\___/\__| |___/ |_/_/ \_\_| |___|
//------------------------------------------------------------------------------------
#define BOT_STATE_STAND			0			// Bot Standing
#define BOT_STATE_MOVE			1			// Bot Moving
#define BOT_STATE_ATTACK		2			// Bot Attacking
#define BOT_STATE_WANDER		3			// Bot Wandering
#define BOT_STATE_FLEE			4			// Bot Fleeing
#define BOT_STATE_POSITION		5			// Bot Position

#define BOT_MOVE_LEFT			0			// Bot Move Left
#define BOT_MOVE_RIGHT			1			// Bot Move Right
#define BOT_MOVE_FORWARD		2			// Bot Move Forward
#define BOT_MOVE_BACK			3			// Bot Move Back
//------------------------------------------------------------------------------------

//  ___ _               _    _    _
// |_ _| |_ ___ _ __   | |  (_)__| |_
//  | ||  _/ -_) '  \  | |__| (_-<  _|
// |___|\__\___|_|_|_| |____|_/__/\__|
//------------------------------------------------------------------------------------
#define ITEMLIST_NULLINDEX			0		// Item Null
#define ITEMLIST_BODYARMOR			1		// Item Body Armor
#define ITEMLIST_COMBATARMOR		2		// Item Combat Armor
#define ITEMLIST_JACKETARMOR		3		// Item Jacket Armor
#define ITEMLIST_ARMORSHARD			4		// Item Armor Shard
#define ITEMLIST_POWERSCREEN		5		// Item Powerscreen
#define ITEMLIST_POWERSHIELD		6		// Item Powershield

#define ITEMLIST_GRAPPLE            7		// Item Grapple

#define ITEMLIST_BLASTER			8		// Weapon Blaster
#define ITEMLIST_SHOTGUN			9		// Weapon Shotgun
//qbism remove #define ITEMLIST_SUPERSHOTGUN		10		// Weapon Supershotgun
#define ITEMLIST_MACHINEGUN			10		// Weapon Machinegun
#define ITEMLIST_CHAINGUN			11		// Weapon Chaingun
#define ITEMLIST_GRENADES			12		// Weapon Grenades
#define ITEMLIST_GRENADELAUNCHER	13		// Weapon Grenade Launcher
#define ITEMLIST_ROCKETLAUNCHER		14		// Weapon Rocket Launcher
#define ITEMLIST_HYPERBLASTER		15		// Weapon Hyper-Blaster
#define ITEMLIST_RAILGUN			16		// Weapon Railgun
#define ITEMLIST_BFG10K				17		// Weapon BFG

#define ITEMLIST_SHELLS				18		// Ammo Shells
#define ITEMLIST_BULLETS			19		// Ammo Bullets
#define ITEMLIST_CELLS				20		// Ammo Cells
#define ITEMLIST_ROCKETS			21		// Ammo Rockets
#define ITEMLIST_SLUGS				22		// Ammo Slugs
#define ITEMLIST_QUADDAMAGE			23		// Power-up Quad Damage
#define ITEMLIST_INVULNERABILITY	24		// Power-up Invulnerability
#define ITEMLIST_SILENCER			25		// Power-up Silencer
#define ITEMLIST_REBREATHER			26		// Power-up Rebreather
#define ITEMLIST_ENVIRONMENTSUIT	27		// Power-up Environmentsuit
#define ITEMLIST_ANCIENTHEAD		28		// Power-up Ancient Head
#define ITEMLIST_ADRENALINE			29		// Power-up Adrenaline
#define ITEMLIST_BANDOLIER			30		// Power-up Bandolier
#define ITEMLIST_AMMOPACK			31		// Power-up Ammo Pack
#define ITEMLIST_DATACD				32		// Power-up Data CD
#define ITEMLIST_POWERCUBE			33		// Power-up Power Cube
#define ITEMLIST_PYRAMIDKEY			34		// Power-up Pyramid Key
#define ITEMLIST_DATASPINNER		35		// Power-up Data Spinner
#define ITEMLIST_SECURITYPASS		36		// Power-up Security Pass
#define ITEMLIST_BLUEKEY			37		// Power-up Blue Key
#define ITEMLIST_REDKEY				38		// Power-up Red Key
#define ITEMLIST_COMMANDERSHEAD		39		// Power-up Commanders Head
#define ITEMLIST_AIRSTRIKEMARKER	40		// Power-up Airstrike Marker
#define ITEMLIST_HEALTH				41		// Power-up Health

#define ITEMLIST_FLAG1              42		// CTF Red Flag
#define ITEMLIST_FLAG2              43		// CTF Blue Flag
#define ITEMLIST_RESISTANCETECH     44		// CTF Tech - Resistance
#define ITEMLIST_STRENGTHTECH       45		// CTF Tech - Strength
#define ITEMLIST_HASTETECH          46		// CTF Tech - Haste
#define ITEMLIST_REGENERATIONTECH   47		// CTF Tech - Regeneration

#define ITEMLIST_HEALTH_SMALL		48		// Health - Small
#define ITEMLIST_HEALTH_MEDIUM		49		// Health - Medium
#define ITEMLIST_HEALTH_LARGE		50		// Health - Large
#define ITEMLIST_BOT				51		// Bot
#define ITEMLIST_PLAYER				52		// Player
#define ITEMLIST_HEALTH_MEGA        53		// Health - MEGA
//------------------------------------------------------------------------------------

//  _  _         _       ___     _         _ _    _
// | \| |___  __| |___  | _ \___| |__ _  _(_) |__| |
// | .` / _ \/ _` / -_) |   / -_) '_ \ || | | / _` |
// |_|\_\___/\__,_\___| |_|_\___|_.__/\_,_|_|_\__,_|
//------------------------------------------------------------------------------------
qboolean	dorebuild;			// for rebuilding nodes
//------------------------------------------------------------------------------------

//  _  _         _       _    _      _     ___ _               _
// | \| |___  __| |___  | |  (_)_ _ | |__ / __| |_ _ _ _  _ __| |_ _  _ _ _ ___
// | .` / _ \/ _` / -_) | |__| | ' \| / / \__ \  _| '_| || / _|  _| || | '_/ -_)
// |_|\_\___/\__,_\___| |____|_|_||_|_\_\ |___/\__|_|  \_,_\__|\__|\_,_|_| \___|
//------------------------------------------------------------------------------------
typedef struct nodelink_s		// Node Link Structure
{
	short int		targetNode;	// Target Node
	float			cost;		// Cost for PathSearch algorithm

}nodelink_t;					// Node Link Typedef
//------------------------------------------------------------------------------------

//  _  _         _       ___ _               _
// | \| |___  __| |___  / __| |_ _ _ _  _ __| |_ _  _ _ _ ___
// | .` / _ \/ _` / -_) \__ \  _| '_| || / _|  _| || | '_/ -_)
// |_|\_\___/\__,_\___| |___/\__|_|  \_,_\__|\__|\_,_|_| \___|
//------------------------------------------------------------------------------------
typedef struct node_s			// Node Structure
{
	vec3_t		origin;			// Node Origin
	int			type;			// Node Type
	short int	nodenum;		// Node Number
	nodelink_t	links[MAXLINKS];// Store all links
} node_t;						// Node Typedef
//------------------------------------------------------------------------------------

//  ___ _               ___ _               _
// |_ _| |_ ___ _ __   / __| |_ _ _ _  _ __| |_ _  _ _ _ ___
//  | ||  _/ -_) '  \  \__ \  _| '_| || / _|  _| || | '_/ -_)
// |___|\__\___|_|_|_| |___/\__|_|  \_,_\__|\__|\_,_|_| \___|
//------------------------------------------------------------------------------------
typedef struct item_table_s		// Item Table Structure
{
	int			item;			// Item
	float		weight;			// Weight
	edict_t		*ent;			// Entity
	int			node;			// Node

} item_table_t;					// Item Table Typedef
//------------------------------------------------------------------------------------

//  ___     _                     _
// | __|_ _| |_ ___ _ _ _ _  __ _| |___
// | _|\ \ /  _/ -_) '_| ' \/ _` | (_-<
// |___/_\_\\__\___|_| |_||_\__,_|_/__/
//------------------------------------------------------------------------------------
extern node_t		nodes[MAX_NODES];		// Node Table
extern item_table_t item_table[MAX_EDICTS];	// Item Table
extern qboolean		debug_mode;				// Debug Mode
extern int			number_of_nodes;		// Number Of Nodes
extern int			num_items;				// Number Of Items
extern int			num_players;			// Number of Players
extern edict_t		*players[MAX_CLIENTS];	// Pointers to all players in the game

//------------------------------------------------------------------------------------


//  ___    _   ___             _   _
// |_ _|__| | | __|  _ _ _  __| |_(_)___ _ _  ___
//  | |/ _` | | _| || | ' \/ _|  _| / _ \ ' \(_-<
// |___\__,_| |_| \_,_|_||_\__|\__|_\___/_||_/__/
//------------------------------------------------------------------------------------
void		LookAtKiller (edict_t *self, edict_t *inflictor, edict_t *attacker);
void		ClientObituary (edict_t *self, edict_t *inflictor, edict_t *attacker);
void		TossClientWeapon (edict_t *self);
void		ClientThink (edict_t *ent, usercmd_t *ucmd);
void		SelectSpawnPoint (edict_t *ent, vec3_t origin, vec3_t angles);
void		ClientUserinfoChanged (edict_t *ent, char *userinfo);
void		CopyToBodyQue (edict_t *ent);
qboolean	ClientConnect (edict_t *ent, char *userinfo);
void		Use_Plat (edict_t *ent, edict_t *other, edict_t *activator);
//------------------------------------------------------------------------------------

//    _     ___
//   /_\   |_ _|
//  / _ \ _ | | _
// /_/ \_(_)___(_)
// fusionbot_ai.c
//------------------------------------------------------------------------------------
void		FUSION_AI_Think (edict_t *fusionbot);
void		FUSION_AI_Determine_LR_Goal(edict_t *fusionbot);
void		FUSION_AI_Determine_SR_Goal(edict_t *fusionbot);
qboolean	FUSION_AI_LocateEnemy(edict_t *fusionbot);
void		FUSION_AI_ChooseWeapon(edict_t *fusionbot);
void		FUSION_AI_ChoosePreferredWeapon( edict_t *fusionbot, char *s);
//------------------------------------------------------------------------------------

//    _   _  _ ___ __  __   _ _____ ___ ___  _  _
//   /_\ | \| |_ _|  \/  | /_\_   _|_ _/ _ \| \| |
//  / _ \| .` || || |\/| |/ _ \| |  | | (_) | .` |
// /_/ \_\_|\_|___|_|  |_/_/ \_\_| |___\___/|_|\_|
// fusionbot_animation.c
//------------------------------------------------------------------------------------
void		FUSION_ANIMATION_RunFrames(edict_t *fusionbot, int start, int end);
void		FUSION_ANIMATION_FlipTheFinger(edict_t *fusionbot);
void		FUSION_ANIMATION_Taunt(edict_t *fusionbot);
void		FUSION_ANIMATION_Wave(edict_t *fusionbot);
void		FUSION_ANIMATION_Salute(edict_t *fusionbot);
void		FUSION_ANIMATION_Point(edict_t *fusionbot);
void		FUSION_ANIMATION_BotPain (edict_t *fusionbot, edict_t *other, float kick, int damage);
void		FUSION_ANIMATION_BotPainThink(edict_t *fusionbot);
//------------------------------------------------------------------------------------

//   ___ ___  __  __ __  __   _   _  _ ___  ___
//  / __/ _ \|  \/  |  \/  | /_\ | \| |   \/ __|
// | (_| (_) | |\/| | |\/| |/ _ \| .` | |) \__ \
//  \___\___/|_|  |_|_|  |_/_/ \_\_|\_|___/|___/
// fusionbot_cmds.c
//------------------------------------------------------------------------------------
qboolean	FUSION_CMD_Commands(edict_t *ent);
void		FUSION_CMD_Store();
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
//  ___ _____ ___ __  __ ___
// |_ _|_   _| __|  \/  / __|
//  | |  | | | _|| |\/| \__ \
// |___| |_| |___|_|  |_|___/
// fusionbot_items.c
//------------------------------------------------------------------------------------
void		FUSION_ITEMS_FusionBotAdded(edict_t *ent);
void		FUSION_ITEMS_FusionBotRemoved(edict_t *ent);
qboolean	FUSION_ITEMS_IsVisible(edict_t *fusionbot, vec3_t goal);
qboolean	FUSION_ITEMS_IsReachable(edict_t *fusionbot,vec3_t goal);
qboolean	FUSION_ITEMS_ChangeWeapon (edict_t *ent, gitem_t *item);
qboolean	FUSION_ITEMS_CanUseArmor (gitem_t *item, edict_t *other);
float		FUSION_ITEMS_ItemNeed(edict_t *fusionbot, int item);
int			FUSION_ITEMS_ClassnameToIndex(char *classname);
void		FUSION_ITEMS_BuildItemNodeTable (qboolean rebuild);
//------------------------------------------------------------------------------------

//  __  __   _   ___ ___ ___ _  _  ___
// |  \/  | /_\ | _ \ _ \_ _| \| |/ __|
// | |\/| |/ _ \|  _/  _/| || .` | (_ |
// |_|  |_/_/ \_\_| |_| |___|_|\_|\___|
// fusionbot_mapping.c
//------------------------------------------------------------------------------------
qboolean	FUSION_MAPPING_FollowPath(edict_t *fusionbot);
void		FUSION_MAPPING_GrapFired(edict_t *fusionbot);
qboolean	FUSION_MAPPING_CheckForLadder(edict_t *fusionbot);
void		FUSION_MAPPING_PathMap(edict_t *fusionbot);
void		FUSION_MAPPING_InitNodes(void);
void		FUSION_MAPPING_ShowNode(int node);
void		FUSION_MAPPING_DrawPath(edict_t *fusionbot);
void		FUSION_MAPPING_ShowPath(edict_t *fusionbot, int goal_node);
//------------------------------------------------------------------------------------

//  __  __  _____   _____ __  __ ___ _  _ _____
// |  \/  |/ _ \ \ / / __|  \/  | __| \| |_   _|
// | |\/| | (_) \ V /| _|| |\/| | _|| .` | | |
// |_|  |_|\___/ \_/ |___|_|  |_|___|_|\_| |_|
// fusionbot_movement.c
//------------------------------------------------------------------------------------
qboolean	FUSION_MOVEMENT_SpecialMove(edict_t *fusionbot,usercmd_t *ucmd);
void		FUSION_MOVEMENT_Move(edict_t *fusionbot, usercmd_t *ucmd);
void		FUSION_MOVEMENT_Attack (edict_t *fusionbot, usercmd_t *ucmd);
void		FUSION_MOVEMENT_Wander (edict_t *fusionbot, usercmd_t *ucmd);
//------------------------------------------------------------------------------------

//  _  _   ___   _____ ___   _ _____ ___ ___  _  _
// | \| | /_\ \ / /_ _/ __| /_\_   _|_ _/ _ \| \| |
// | .` |/ _ \ V / | | (_ |/ _ \| |  | | (_) | .` |
// |_|\_/_/ \_\_/ |___\___/_/ \_\_| |___\___/|_|\_|
// fusionbot_navigation.c
//------------------------------------------------------------------------------------
int			FUSION_NAVIGATION_FindCost(int from, int to);
int			FUSION_NAVIGATION_FindCloseReachableNode(edict_t *fusionbot, int dist, int type);
int			FUSION_NAVIGATION_FindClosestReachableNode(edict_t *fusionbot, int range, int type);
int			FUSION_NAVIGATION_FindFlagNode(edict_t *fusionbot, int range, int type);
void		FUSION_NAVIGATION_SetFlagGoal(edict_t *fusionbot, int goal_node);
void		FUSION_NAVIGATION_SetGoal(edict_t *fusionbot, int goal_node);
//------------------------------------------------------------------------------------


//  _  _  ___  ___  ___ ___
// | \| |/ _ \|   \| __/ __|
// | .` | (_) | |) | _|\__ \
// |_|\_|\___/|___/|___|___/
// fusionbot_nodes.c
//------------------------------------------------------------------------------------
int			FUSION_NODES_AddNode(edict_t *fusionbot, int type);
void		FUSION_NODES_UpdateNodeEdge(int from, int to);
void		FUSION_NODES_RemoveNodeEdge(edict_t *fusionbot, int from, int to);
void		FUSION_NODES_ResolveAllPaths();
void		FUSION_NODES_SaveNodes();
void		FUSION_NODES_SaveNodesAgain();
void		FUSION_NODES_LoadNodes();
//------------------------------------------------------------------------------------

//  ___ ___  ___      ___  _
// / __| _ \/_\ \    / / \| |
// \__ \  _/ _ \ \/\/ /| .` |
// |___/_|/_/ \_\_/\_/ |_|\_|
// fusionbot_spawn.c
//------------------------------------------------------------------------------------
int			FUSION_SPAWN_NextCTFTeam();
void		FUSION_SPAWN_SaveBots();
void		FUSION_SPAWN_LoadBots();
void		FUSION_SPAWN_HoldSpawn(edict_t *fusionbot);
void		FUSION_SPAWN_LoadBotConfig(char *cfgfile); //qbism load bot config
void		FUSION_SPAWN_SpawnBotFromConfig( char *inString );
void		FUSION_SPAWN_PutClientInServer (edict_t *fusionbot, qboolean respawn, int team);
void		FUSION_SPAWN_Respawn (edict_t *fusionbot);
edict_t		*FUSION_SPAWN_FindFreeClient (void);
void		FUSION_SPAWN_SetName(edict_t *fusionbot, char *name, char *skin, char *team);
void		FUSION_SPAWN_SpawnBot (char *team, char *name, char *skin, char *userinfo);
void		FUSION_SPAWN_ReAddBots();
void		FUSION_SPAWN_RemoveBot(char *name);
//------------------------------------------------------------------------------------

#endif
