/*

ANIMATION FUNCTION LISTING

FUSION_ANIMATION_RunFrames			 Run Animation Frames
FUSION_ANIMATION_FlipTheFinger		 Play Flipoff Animation
FUSION_ANIMATION_Taunt				 Play Taunt Animation
FUSION_ANIMATION_Wave				 Play Wave Animation
FUSION_ANIMATION_Salute				 Play Salute Animation
FUSION_ANIMATION_Point				 Play Point Animation
FUSION_ANIMATION_BotPain			 Play BotPain Animation
FUSION_ANIMATION_BotPainThink		 BotPain Think Function

*/
/*
               .__                __  .__
 _____    ____ |__| _____ _____ _/  |_|__| ____   ____
 \__  \  /    \|  |/     \\__  \\   __\  |/  _ \ /    \
  / __ \|   |  \  |  Y Y  \/ __ \|  | |  (  <_> )   |  \
 (____  /___|  /__|__|_|  (____  /__| |__|\____/|___|  /
      \/     \/         \/     \/                    \/

	fusionbot_animation.c
	Animation handling routines
	(NOT CURRENTLY USED)
================================================================
Should you decide to release a modified version of FUSION, you MUST
include the following text in the documentation and source of your
modification.

---===[BEGIN TEXT]===---
================================================================
___________           .__                __________        __
\_   _____/_ __  _____|__| ____   ____   \______   \ _____/  |_
 |    __)|  |  \/  ___/  |/  _ \ /    \   |    |  _//  _ \   __\
 |     \ |  |  /\___ \|  (  <_> )   |  \  |    |   (  <_> )  |
 \___  / |____//____  >__|\____/|___|  /  |______  /\____/|__|
     \/             \/               \/          \/  Version 2.0
================================================================
Fusion v2.0
Copyright (c) 1998-2003 Trenton Shaffer.
All rights reserved.

ACEBOT Copyright(c) 1998, Steve Yeager.
EraserBot Copyright(c) 1998, Ryan Feltrin.
QFusion is Copyright (C) 2002-2003 Victor Luchits.
All other files are Copyright(C) 1997-2001 Id Software, Inc.
================================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
================================================================
---===[END TEXT]===---
*/
#include "..\game\g_local.h"
#include "..\game\m_player.h"
#include "fusionbot.h"

//SPLITMODELS: I touched all the functions in this archive without any
//consideration nor knowledge of what I was really doing.
//	-Jal.

//===========================================================================
// Routine		: FUSION_ANIMATION_RunFrames
// Description	: Run Animation Frames
void FUSION_ANIMATION_RunFrames(edict_t *fusionbot, int start, int end)
{
	/*
	if((fusionbot->s.frame < end) && (fusionbot->s.frame >= start))
	{
		fusionbot->s.frame++;
	}
	else
	{
		fusionbot->s.frame = start;
	}
	*/
}

//===========================================================================
// Routine		: FUSION_ANIMATION_FlipTheFinger
// Description	: Flipoff Animation
void FUSION_ANIMATION_FlipTheFinger(edict_t *fusionbot)
{
	if (fusionbot->client->anim_priority < ANIM_WAVE){
		fusionbot->s.frame = TORSO_GESTURE &0x3F;
		fusionbot->client->anim_event_time = TORSO_GESTURE_time;
	}
	//FUSION_ANIMATION_RunFrames(fusionbot, FRAME_flip01, FRAME_flip12);
}

//===========================================================================
// Routine		: FUSION_ANIMATION_Taunt
// Description	: Taunt Animation
void FUSION_ANIMATION_Taunt(edict_t *fusionbot)
{
	if (fusionbot->client->anim_priority < ANIM_WAVE){
		fusionbot->s.frame = TORSO_GESTURE &0x3F;
		fusionbot->client->anim_event_time = TORSO_GESTURE_time;
	}
	//FUSION_ANIMATION_RunFrames(fusionbot, FRAME_taunt01, FRAME_taunt17);
}

//===========================================================================
// Routine		: FUSION_ANIMATION_Wave
// Description	: Wave Animation
void FUSION_ANIMATION_Wave(edict_t *fusionbot)
{
	if (fusionbot->client->anim_priority < ANIM_WAVE){
		fusionbot->s.frame = TORSO_GESTURE &0x3F;
		fusionbot->client->anim_event_time = TORSO_GESTURE_time;
	}
	//FUSION_ANIMATION_RunFrames(fusionbot, FRAME_wave01, FRAME_wave11);
}

//===========================================================================
// Routine		: FUSION_ANIMATION_Salute
// Description	: Salute Animation
void FUSION_ANIMATION_Salute(edict_t *fusionbot)
{
	if (fusionbot->client->anim_priority < ANIM_WAVE){
		fusionbot->s.frame = TORSO_GESTURE &0x3F;
		fusionbot->client->anim_event_time = TORSO_GESTURE_time;
	}
	//FUSION_ANIMATION_RunFrames(fusionbot, FRAME_salute01, FRAME_salute11);
}

//===========================================================================
// Routine		: FUSION_ANIMATION_Point
// Description	: Point Animation
void FUSION_ANIMATION_Point(edict_t *fusionbot)
{
	if (fusionbot->client->anim_priority < ANIM_WAVE){
		fusionbot->s.frame = TORSO_GESTURE &0x3F;
		fusionbot->client->anim_event_time = TORSO_GESTURE_time;
	}
	//FUSION_ANIMATION_RunFrames(fusionbot, FRAME_point01, FRAME_point12);
}

//===========================================================================
// Routine		: FUSION_ANIMATION_BotPain
// Description	: Setup Bot Pain Animation (FIXME)
void FUSION_ANIMATION_BotPain (edict_t *fusionbot, edict_t *other, float kick, int damage)
{
//	gi.bprintf(PRINT_HIGH, "FUSION BOT: in BotPain ... ouch!\n");
//	FUSION_ANIMATION_RunFrames(fusionbot, FRAME_pain101, FRAME_pain104);
	fusionbot->enemy = other;
//	fusionbot->think = FUSION_ANIMATION_BotPainThink;
//	fusionbot->nextthink = level.time + 0.1;
	//fusionbot->monsterinfo.idle_time = level.time + 0.3;

	if (fusionbot->client->anim_priority < ANIM_PAIN){
		fusionbot->s.frame = TORSO_PAIN1 &0x3F;
		fusionbot->client->anim_event_time = TORSO_PAIN1_time;
	}
}

//===========================================================================
// Routine		: FUSION_ANIMATION_BotPainThink
// Description	: Think function for Bot Pain (FIXME)
void FUSION_ANIMATION_BotPainThink(edict_t *fusionbot)
{
	//if (fusionbot->monsterinfo.idle_time >= level.time)
	//{
//		FUSION_ANIMATION_RunFrames(fusionbot, FRAME_pain101, FRAME_pain104);
		if (level.time > fusionbot->pain_debounce_time)
		{
			fusionbot->pain_debounce_time = level.time + 0.7;

			if (fusionbot->health < 25)
				fusionbot->s.event = EV_PAIN25;
			else if (fusionbot->health < 50)
				fusionbot->s.event = EV_PAIN50;
			else if (fusionbot->health < 75)
				fusionbot->s.event = EV_PAIN75;
			else
				fusionbot->s.event = EV_PAIN100;
		}

	//}
	//else
	//{
		//fusionbot->think = player_run;
		fusionbot->think = FUSION_AI_Think;
	//}
	fusionbot->nextthink = level.time + 0.1;
}
