/*
        .__            __
   ____ |  |__ _____ _/  |_
 _/ ___\|  |  \\__  \\   __\
 \  \___|   Y  \/ __ \|  |
  \___  >___|  (____  /__|
      \/     \/     \/

	fusion_chat.c
	Fusion Bot Chat
================================================================
Should you decide to release a modified version of FUSION, you MUST
include the following text in the documentation and source of your
modification.

---===[BEGIN TEXT]===---
================================================================
___________           .__                __________        __
\_   _____/_ __  _____|__| ____   ____   \______   \ _____/  |_
 |    __)|  |  \/  ___/  |/  _ \ /    \   |    |  _//  _ \   __\
 |     \ |  |  /\___ \|  (  <_> )   |  \  |    |   (  <_> )  |
 \___  / |____//____  >__|\____/|___|  /  |______  /\____/|__|
     \/             \/               \/          \/  Version 2.0
================================================================
Fusion v2.0
Copyright (c) 1998-2003 Trenton Shaffer.
All rights reserved.

ACEBOT Copyright(c) 1998, Steve Yeager.
EraserBot Copyright(c) 1998, Ryan Feltrin.
QFusion is Copyright (C) 2002-2003 Victor Luchits.
All other files are Copyright(C) 1997-2001 Id Software, Inc.
================================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
================================================================
---===[END TEXT]===---
*/

#include "..\game\g_local.h"
#include "fusionbot_chat.h"

#define DBC_WELCOMES	13
char	*fusion_welcomes[DBC_WELCOMES] =
{
        "Greetings all!",
        "Hello %s! Your name sounds familiar...",
		"%s? Who is that?",
		"How's it going, %s?",
		"Is %s a family name?",
		"Fight the power, %s.",
		"Rats! I hoped Vic would be here...",
		"Looks like a good crowd ;)",
		"I gotta find a better server...",
		"Hey, any of you guys played before?",
		"Hi %s, I wondered if you'd show up around here again.",
		"^2Nice :-) :-) :-)^2",
		"OK %s, let's get this over with"
};

#define	DBC_KILLS 13
char	*fusion_kills[DBC_KILLS] =
{
        "Hey! %s messed up my hair.",
        "All right, %s. Now I'm really mad!",
        "Hey! Go easy on me! I'm a newbie!",
		"Ooooh, %s, that smarts!",
		"%s's mother cooks socks in hell!",
		"Hey, %s, let me return the favor.",
		"Was %s talking to me, or chewing a brick?",
		"Aw, %s doesn't like me...",
		"It's clobberin' time, %s",
		"Hey, I was tying my shoelace!",
		"Oh - now I know how strawberry jam feels...",
		"laaaaaaaaaaaaaaag!",
		"I feel like chicken tonight...."
};

#define DBC_INSULTS	16
char	*fusion_insults[DBC_INSULTS] =
{
        "Hey, %s. Your mother was a hamster...!",
        "%s; Eat my dust!",
        "Hahaha! Hook, Line and Sinker, %s!",
		"I'm sorry, %s, did I break your concentration?",
		"Unlike certain other bots, %s, I can kill with an English accent..",
		"Get used to disappointment, %s",
		"Didn't mean to wake you up, %s",
		"%s, does your mother know you're out?",
		"Hey, %s, one guy wins, the other loses...",
		"Oh %s, ever thought of taking up croquet instead?",
		"Yuck! I've got some %s on my shoe!",
		"Mmmmm... %s chunks!",
		"Hey everyone, %s was better than the Pirates of Penzance",
		"Oh - good play %s ... hehehe",
		"Errm, %s, maybe try some turn-based game?",
		"Ooooooh - I'm sooooo scared %s"
};

void FUSION_CHAT_Chat (edict_t *fusionbot, edict_t *object, int speech)
{
	char final[150];
	char *text;
	char text2[150];
	char plname[34];

    if ((!object) || (!object->client))
		return;

    if (speech == DBC_WELCOME)
		text = fusion_welcomes[rand()%DBC_WELCOMES];
    else if (speech == DBC_KILLED)
		text = fusion_kills[rand()%DBC_KILLS];
    else if (speech = DBC_INSULT)
		text = fusion_insults[rand()%DBC_INSULTS];
    else if( debug_mode )
   {
		gi.bprintf (PRINT_HIGH, "FUSION BOT: Unknown speech type attempted!(out of range)");
        return;
    }
 	strcpy( plname, object->client->pers.netname);
	strcat( plname, "^2");

	strcpy( text2, "^2");
	strcat( text2, text);
	strcat( text2, "^2");
	sprintf (final, text2, plname);

 	FUSION_CHAT_Say (fusionbot, final);
}

void FUSION_CHAT_Say (edict_t *ent, char *what)
{
	int		j;
	edict_t	*other;
	char	text[2048];

        Com_sprintf (text, sizeof(text), "%s: ", ent->client->pers.netname);

        if (*what == '"')
        {
                what++;
                what[strlen(what)-1] = 0;
        }
        strcat(text, what);

	// don't let text be too long for malicious reasons
        if (strlen(text) > 200)
                text[200] = '\0';

	strcat(text, "\n");

	if (dedicated->value)
		gi.cprintf(NULL, PRINT_CHAT, "%s", text);

	for (j = 1; j <= game.maxclients; j++)
	{
		other = &g_edicts[j];
		if (!other->inuse)
			continue;
		if (!other->client)
			continue;
        if (Q_stricmp(other->classname, "bot") == 0)
            continue;
		gi.cprintf(other, PRINT_CHAT, "%s", text);
	}
}

