/*
                     .___
   ____   _____    __| _/______
 _/ ___\ /     \  / __ |/  ___/
 \  \___|  Y Y  \/ /_/ |\___ \
  \___  >__|_|  /\____ /____  >
      \/      \/      \/    \/

	fusionbot_cmds.c
	Main internal command processor
================================================================
Should you decide to release a modified version of FUSION, you MUST
include the following text in the documentation and source of your
modification.

---===[BEGIN TEXT]===---
================================================================
___________           .__                __________        __
\_   _____/_ __  _____|__| ____   ____   \______   \ _____/  |_
 |    __)|  |  \/  ___/  |/  _ \ /    \   |    |  _//  _ \   __\
 |     \ |  |  /\___ \|  (  <_> )   |  \  |    |   (  <_> )  |
 \___  / |____//____  >__|\____/|___|  /  |______  /\____/|__|
     \/             \/               \/          \/  Version 2.0
================================================================
Fusion v2.0
Copyright (c) 1998-2003 Trenton Shaffer.
All rights reserved.

ACEBOT Copyright(c) 1998, Steve Yeager.
EraserBot Copyright(c) 1998, Ryan Feltrin.
QFusion is Copyright (C) 2002-2003 Victor Luchits.
All other files are Copyright(C) 1997-2001 Id Software, Inc.
================================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
================================================================
---===[END TEXT]===---
*/
#include "..\game\g_local.h"
#include "fusionbot.h"

qboolean debug_mode=qfalse;

//===========================================================================
// Routine		: FUSION_CMD_Commands
// Description	: Special command processor
qboolean FUSION_CMD_Commands(edict_t *ent)
{
	char	*cmd;
	int node;

	cmd = gi.argv(0);

		// addnode
		//-------------------------------------------------------
		if(Q_stricmp (cmd, "addnode") == 0 && debug_mode)
			ent->last_node = FUSION_NODES_AddNode(ent,atoi(gi.argv(1)));
		//-------------------------------------------------------

		// removelink
		//-------------------------------------------------------
		else if(Q_stricmp (cmd, "removelink") == 0 && debug_mode)
			FUSION_NODES_RemoveNodeEdge(ent,atoi(gi.argv(1)), atoi(gi.argv(2)));
		//-------------------------------------------------------

		// addlink
		//-------------------------------------------------------
		else if(Q_stricmp (cmd, "addlink") == 0 && debug_mode)
			FUSION_NODES_UpdateNodeEdge(atoi(gi.argv(1)), atoi(gi.argv(2)));
		//-------------------------------------------------------

		// showpath
		//-------------------------------------------------------
		else if(Q_stricmp (cmd, "showpath") == 0 && debug_mode)
    		FUSION_MAPPING_ShowPath(ent,atoi(gi.argv(1)));
		//-------------------------------------------------------

		// findnode
		//-------------------------------------------------------
		else if(Q_stricmp (cmd, "findnode") == 0 && debug_mode)
		{
			node = FUSION_NAVIGATION_FindClosestReachableNode(ent,NODE_DENSITY, NODE_ALL);
			gi.bprintf(PRINT_MEDIUM,"FUSION BOT: node: %d type: %d x: %f y: %f z %f\n",node,nodes[node].type,nodes[node].origin[0],nodes[node].origin[1],nodes[node].origin[2]);
		}
		//-------------------------------------------------------

		// movenode
		//-------------------------------------------------------
		else if(Q_stricmp (cmd, "movenode") == 0 && debug_mode)
		{
			node = atoi(gi.argv(1));
			nodes[node].origin[0] = atof(gi.argv(2));
			nodes[node].origin[1] = atof(gi.argv(3));
			nodes[node].origin[2] = atof(gi.argv(4));
			gi.bprintf(PRINT_MEDIUM,"FUSION BOT: node: %d moved to x: %f y: %f z %f\n",node, nodes[node].origin[0],nodes[node].origin[1],nodes[node].origin[2]);
		}
		//-------------------------------------------------------
		else
			return qfalse;

	return qtrue;
}

//===========================================================================
// Routine		: FUSION_CMD_Store
// Description	: Stores node maps and bots
void FUSION_CMD_Store()
{
	FUSION_NODES_SaveNodes();
}

