/*
   _____       ___   _____   _   _   _   __   _   _____  
  |  _  \     /   | |_   _| | | | | | | |  \ | | /  ___| 
  | |_| |    / /| |   | |   | |_| | | | |   \| | | |     
  |  ___/   / / | |   | |   |  _  | | | | |\   | | |  _  
  | |      / /  | |   | |   | | | | | | | | \  | | |_| | 
  |_|     /_/   |_|   |_|   |_| |_| |_| |_|  \_| \_____/

	fusionbot_pathing.h
	NEW pathing routines for the FUSION bot
================================================================
Should you decide to release a modified version of FUSION, you MUST
include the following text in the documentation and source of your 
modification.

---===[BEGIN TEXT]===---
================================================================
___________           .__                __________        __   
\_   _____/_ __  _____|__| ____   ____   \______   \ _____/  |_ 
 |    __)|  |  \/  ___/  |/  _ \ /    \   |    |  _//  _ \   __\
 |     \ |  |  /\___ \|  (  <_> )   |  \  |    |   (  <_> )  |  
 \___  / |____//____  >__|\____/|___|  /  |______  /\____/|__|  
     \/             \/               \/          \/  Version 2.0          
================================================================ 
Fusion v2.0
Copyright (c) 1998-2003 Trenton Shaffer.
All rights reserved.

ACEBOT Copyright(c) 1998, Steve Yeager.
EraserBot Copyright(c) 1998, Ryan Feltrin.
QFusion is Copyright (C) 2002-2003 Victor Luchits.
All other files are Copyright(C) 1997-2001 Id Software, Inc.
================================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
================================================================
---===[END TEXT]===---
*/
#define		PA_FREQ		0.5

qboolean	FUSION_PA_PathMove (edict_t *self);
void		FUSION_PA_InitSearch (edict_t *fusionbot);
qboolean	FUSION_PA_StartSearch (edict_t *fusionbot, int from, int to);
qboolean	FUSION_PA_QuickPath (edict_t *fusionbot, int from, int to);
qboolean	FUSION_PA_FindPath (edict_t *fusionbot, int from, int to);
qboolean	FUSION_PA_LinkExists (int from, int to);

enum
{
	FUSION_ROAM,
	FUSION_ATTACK,
	FUSION_ATTACKCOLLECT,
	FUSION_CAMP,
	FUSION_SNIPER,
	FUSION_AMBUSH
};

typedef struct single_link
{
	struct single_link	*next;
	int					nodedata;
} single_link_t;

typedef struct
{
	single_link_t	*head;
	single_link_t	*tail;
} fusion_link_t;

void	FUSION_PA_SLPush_Front (fusion_link_t *list, int nodedata);
void	FUSION_PA_SLPop_Front (fusion_link_t *list);
int		FUSION_PA_SLFront (fusion_link_t *list);
void	FUSION_PA_SLPush_Back (fusion_link_t *list, int nodedata);
qboolean FUSION_PA_SLEmpty (fusion_link_t *list);
void	FUSION_PA_SLDelete (fusion_link_t *list);