/*
   ______ ____ _____    ____  
  /  ___// ___\\__  \  /    \ 
  \___ \\  \___ / __ \|   |  \
 /____  >\___  >____  /___|  /
      \/     \/     \/     \/ 

	fusionbot_scan.h
	A lexical scanner module for complex configuration files
================================================================
Should you decide to release a modified version of FUSION, you MUST
include the following text in the documentation and source of your 
modification.

---===[BEGIN TEXT]===---
================================================================
___________           .__                __________        __   
\_   _____/_ __  _____|__| ____   ____   \______   \ _____/  |_ 
 |    __)|  |  \/  ___/  |/  _ \ /    \   |    |  _//  _ \   __\
 |     \ |  |  /\___ \|  (  <_> )   |  \  |    |   (  <_> )  |  
 \___  / |____//____  >__|\____/|___|  /  |______  /\____/|__|  
     \/             \/               \/          \/  Version 2.0          
================================================================ 
Fusion v2.0
Copyright (c) 1998-2003 Trenton Shaffer.
All rights reserved.

ACEBOT Copyright(c) 1998, Steve Yeager.
EraserBot Copyright(c) 1998, Ryan Feltrin.
QFusion is Copyright (C) 2002-2003 Victor Luchits.
All other files are Copyright(C) 1997-2001 Id Software, Inc.
================================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
================================================================
---===[END TEXT]===---
*/

#define LEXERR	0
#define SYMBOL	1
#define INTLIT	2
#define REALLIT 3
#define STRLIT	4
#define LPAREN	5
#define RPAREN	6
#define SEMIC	7
#define COLON	8
#define COMMA	9
#define PERIOD	10
#define APOST	11
#define PLUSOP	12
#define MINUSOP 13
#define MUXOP	14
#define DIVOP	15
#define	POWOP	16
#define	ASSIGNOP	17
#define HASH	18
#define BANG	19
#define	EOL		20
#define UNDEF	255

void	FUSION_SCAN_Scanner( char **text, char *token, int *ttype);
char	*FUSION_SCAN_nmtoken( int ttype );
