/*
Copyright (C) 1997-2001 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#define MODEL_SCALE		1.000000


//JALISKO'S SPLITMODELS FRAMES (list)
//surfing info: the code belong to the models system is commented as "splitmodels"
//the code belong to the in-eyes chasecam is commented as "CHASEHACK" (& "splitmodels")

//
// -Torso DEATH frames and Legs DEATH frames must be the same.
//
// -The Torso animations with client priority superior to ANIM_BASIC override
// the basic animations routines. We need to time them to know when this 
// overriding has to stop. The defines with the format "BLAH_BLAH_time" are the
// timers for the animations "BLAH_BLAH". It is recommended that that 
// FLIPIN & FLIPOUT animations are made at 10 fps and it's timers fit the
// number of frames in the script, as that all the models have the same frames
// for those animations, so the synchronization game-client is perfect.
// It's also recommended that all the DEATH animations happen at the same fps,
// and recalculate the timers for those fps.
//
// The other animations transitions aren't that much dependant of their timers.

// timers (in game frames, 0.1 secs)
#define BOTH_DEATH1_time			30
#define BOTH_DEATH2_time			30
#define BOTH_DEATH3_time			30
#define TORSO_GESTURE_time			40
#define TORSO_ATTACK1_time			6
#define TORSO_ATTACK2_time			6
#define TORSO_FLIPOUT_time			5
#define TORSO_FLIPIN_time			4
#define TORSO_DROPHOLD_time		    1
#define TORSO_DROP_time				5
#define TORSO_PAIN1_time			4
#define TORSO_PAIN2_time			4
#define TORSO_PAIN3_time			4

// since this point it must mirror the one at cl_players.h

//-------------------------------------------------------
//					animation config
//-------------------------------------------------------

//DEATHS
#define BOTH_DEATH1					1	//Death1

#define BOTH_DEAD1					2	//DEAD versions are only used for the dead corpses, and are frozen animations on the last frame.

#define BOTH_DEATH2					3	//Death2	

#define BOTH_DEAD2					4	//corpse on the ground

#define BOTH_DEATH3					5	//Death3

#define BOTH_DEAD3					6	//corpse on the ground

#define TORSO_GESTURE				7	//(wave) 


//TORSO
#define TORSO_ATTACK1				8	//Attack	

#define TORSO_ATTACK2				9	//Attack2 (gaunlet) (DROP replacement)	

#define TORSO_FLIPOUT				10	//(weapon drop)

#define TORSO_FLIPIN				11	//(weapon raise)	

#define TORSO_STAND					12	//Stand

#define TORSO_STAND2				13	//Stand2 (gaunlet) (PAIN replacement)

//--------------------- offset

//LEGS
#define LEGS_CRWALK					14	//Crouched Walk

#define LEGS_WALKFWD				15	//WalkFordward (few frames of this will show when moving by inertia)

#define LEGS_RUNFWD					16	//RunFordward

#define LEGS_RUNBACK				17	//RunBackward

#define LEGS_SWIMFWD				18	//Swim Fordward

#define LEGS_JUMP1					19	//Left leg Jump

#define LEGS_JUMP1ST				20	//Left leg land

#define LEGS_JUMP3					21	//Stand & Backwards jump.

#define LEGS_JUMP3ST				22	//Stand & Backwards land.

#define LEGS_STAND					23	//Stand

#define LEGS_CRSTAND				24	//Crouched Stand

#define LEGS_TURN					25	//good for nothing. Not used. It's here just for Q3 models support.


//JAL EXTRA STUFF
#define LEGS_JUMP2					26	//Right leg Jump

#define LEGS_JUMP2ST				27	//Right leg land

#define LEGS_SWIM					28	//Stand & Backwards Swim

#define LEGS_WALKBACK				29	//WalkBackward

#define LEGS_WALKLEFT				30	//WalkLeft

#define LEGS_WALKRIGHT				31	//WalkRight

#define LEGS_RUNLEFT				32	//RunLeft

#define LEGS_RUNRIGHT				33	//RunRight

#define TORSO_RUN					34	//Run (also used for jump)

#define TORSO_SWIM					35	//Swim

#define TORSO_DROPHOLD				36	//Drop hold is only used at handgrenade activation.

#define TORSO_DROP					37	//Drop: true DROP animation	

#define TORSO_PAIN1					38	//Pain1	

#define TORSO_PAIN2					39	//Pain2	

#define TORSO_PAIN3					40	//Pain3	

#define TORSO_CRSTAND				41	//Crouched Stand

#define TORSO_CRWALK				42	//Crouched Walk
