/*
Copyright (C) 2002-2003 Victor Luchits

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef __QFCONFIG_H__
# define __QFCONFIG_H__

#ifdef _WIN32
# include "win32conf.h"
#elif defined __linux__
# include "linuxconf.h"
#endif

#ifdef HAS___INLINE
# ifndef inline
#  define inline __inline
# endif
#endif

#ifdef HAS__SNPRINTF
# ifndef snprintf
#  define snprintf _snprintf
# endif
#endif

#ifdef HAS__VSNPRINTF
# ifndef vsnprintf
#  define vsnprintf _vsnprintf
# endif
#endif

#ifdef HAS__STRICMP
# ifndef Q_stricmp
#  define Q_stricmp(s1, s2) stricmp((s1), (s2))  //qbism was _stricmp, remove _ for lcc
# endif
# ifndef Q_strnicmp
#  define Q_strnicmp(s1, s2, n) strnicmp((s1), (s2), (n))  //qbism was _stricmp, remove _ for lcc
# endif
#endif

#ifdef HAS_STRCASECMP
# ifndef Q_stricmp
#  define Q_stricmp(s1, s2) strcasecmp((s1), (s2))
# endif
# ifndef Q_strnicmp
#  define Q_strnicmp(s1, s2, n) strncasecmp((s1), (s2), (n))
# endif
#endif

#if (defined _M_IX86 || defined __i386__) && !defined C_ONLY
# define id386
#else
# ifdef id386
#  undef id386
# endif
#endif

#ifndef BUILDSTRING
# define BUILDSTRING "NON-WIN32"
#endif

#ifndef CPUSTRING
# define CPUSTRING	"NON-WIN32"
#endif

#ifdef HAS_TCHAR
# include <tchar.h>
#endif

#endif //__QFCONFIG_H__

